#
# spec file for package fence-agents
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global plugin_dir %{_libdir}/stonith/plugins/rhcs

Name:           fence-agents
Summary:        Fence Agents for Pacemaker from RHCS
License:        GPL-2.0 and LGPL-2.1
Group:          Productivity/Clustering/HA
Version:        4.0.20
Release:        3.28
Url:            https://github.com/ClusterLabs/fence-agents
Source0:        %{name}-%{version}.tar.xz

Requires:       python-curl
Requires:       python-openssl
Requires:       python-pexpect
Requires:       python-requests
Requires:       python-suds

BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  glibc-devel
BuildRequires:  libtool
BuildRequires:  libxml2-tools
BuildRequires:  libxslt
BuildRequires:  mozilla-nspr-devel
BuildRequires:  mozilla-nss-devel
BuildRequires:  perl
BuildRequires:  perl-Net-Telnet
BuildRequires:  pkg-config
BuildRequires:  python
BuildRequires:  python-curl
BuildRequires:  python-pexpect
BuildRequires:  python-requests
BuildRequires:  python-suds
BuildRequires:  python-xml
BuildRequires:  xz

%package -n fence-agents-unsupported
Summary:        Fence Agents for Pacemaker from RHCS
Group:          Productivity/Clustering/HA
Requires:       %{name} = %{version}-%{release}
# These are requirements of specific fencing agents; when moving the
# agent over to the supported main package, make sure to also shift the
# Requires if needed
Requires:       net-snmp
Requires:       openssh
Requires:       perl-Net-Telnet
Requires:       sg3_utils
Requires:       telnet
# for fence_vmware_soap:
Requires:       python-suds
# This is required by fence_virsh. Per discussion on fedora-devel
# switching from package to file based require.
Requires:       /usr/bin/virsh

# This is required by fence_ipmilan. it appears that the packages
# have changed Requires around. Make sure to get the right one.
Requires:       /usr/bin/ipmitool

%description
Fence Agents is a collection of scripts to handle remote power
management for several devices.



Authors:
--------
    Abhijith Das <adas@redhat.com>
    Adam Manthei <amanthei@redhat.com>
    A. J. Lewis <alewis@redhat.com>
    Alasdair G. Kergon <agk@redhat.com>
    Andrew Price <andy@andrewprice.me.uk>
    Benjamin Marzinski <bmarzins@redhat.com>
    Bob Peterson <rpeterso@redhat.com>
    Chris Feist <cfeist@redhat.com>
    Christine Caulfield <ccaulfie@redhat.com>
    Daniel Phillips <phillips@redhat.com>
    David Teigland <teigland@redhat.com>
    Fabio M. Di Nitto <fdinitto@redhat.com>
    James Parsons <jparsons@redhat.com>
    Joel Becker <joel.becker@oracle.com>
    Jonathan Brassow <jbrassow@redhat.com>
    jparsons <jparsons@redhat.com>
    Ken Preslan <kpreslan@redhat.com>
    Lon Hohberger <lhh@redhat.com>
    Marc - A. Dahlhaus <mad@wol.de>
    Marek 'marx' Grac <mgrac@redhat.com>
    Mark Hlawatschek <hlawatschek@atix.de>
    Michael Conrad Tadpol Tilstra <mtilstra@redhat.com>
    Patrick Caulfield <pcaulfie@redhat.com>
    Robert Peterson <rpeterso@redhat.com>
    Ross Vandegrift <ross@kallisti.us>
    Ryan McCabe <rmccabe@redhat.com>
    Ryan O'Hara <rohara@redhat.com>
    Stanko Kupcevic <kupcevic@redhat.com>
    Steven Whitehouse <swhiteho@redhat.com>
    Wendy Cheng <wcheng@redhat.com>

%description -n fence-agents-unsupported
Fence Agents is a collection of scripts to handle remote power
management for several devices.



Authors:
--------
    Abhijith Das <adas@redhat.com>
    Adam Manthei <amanthei@redhat.com>
    A. J. Lewis <alewis@redhat.com>
    Alasdair G. Kergon <agk@redhat.com>
    Andrew Price <andy@andrewprice.me.uk>
    Benjamin Marzinski <bmarzins@redhat.com>
    Bob Peterson <rpeterso@redhat.com>
    Chris Feist <cfeist@redhat.com>
    Christine Caulfield <ccaulfie@redhat.com>
    Daniel Phillips <phillips@redhat.com>
    David Teigland <teigland@redhat.com>
    Fabio M. Di Nitto <fdinitto@redhat.com>
    James Parsons <jparsons@redhat.com>
    Joel Becker <joel.becker@oracle.com>
    Jonathan Brassow <jbrassow@redhat.com>
    jparsons <jparsons@redhat.com>
    Ken Preslan <kpreslan@redhat.com>
    Lon Hohberger <lhh@redhat.com>
    Marc - A. Dahlhaus <mad@wol.de>
    Marek 'marx' Grac <mgrac@redhat.com>
    Mark Hlawatschek <hlawatschek@atix.de>
    Michael Conrad Tadpol Tilstra <mtilstra@redhat.com>
    Patrick Caulfield <pcaulfie@redhat.com>
    Robert Peterson <rpeterso@redhat.com>
    Ross Vandegrift <ross@kallisti.us>
    Ryan McCabe <rmccabe@redhat.com>
    Ryan O'Hara <rohara@redhat.com>
    Stanko Kupcevic <kupcevic@redhat.com>
    Steven Whitehouse <swhiteho@redhat.com>
    Wendy Cheng <wcheng@redhat.com>

%prep
%setup -q -n %{name}-%{version}

%build
CFLAGS="${CFLAGS} ${RPM_OPT_FLAGS}"
export CFLAGS
./autogen.sh
%{configure}
make

%install
make install DESTDIR=%{buildroot}

## tree fix up
# fix libfence permissions
chmod 0755 %{buildroot}%{_datadir}/fence/*.py
# remove docs
rm -rf %{buildroot}/usr/share/doc/fence-agents
# create links to agents in the plugins dir
mkdir -p %{buildroot}%{plugin_dir}
ln -s %{_sbindir}/fence_cisco_ucs %{buildroot}%{plugin_dir}

%clean
if
  [ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ]
then
  rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-,root,root,-)
%doc doc/COPYING.* doc/COPYRIGHT doc/README.licence
#%%dir %%{_sysconfdir}/cluster
%dir %{plugin_dir}
%dir %{_libdir}/stonith/plugins
%dir %{_libdir}/stonith
%{_datadir}/fence
%{_datadir}/cluster
#%%{_sbindir}/fence_cisco_ucs
#%%{_mandir}/man8/fence_cisco_ucs*
%{plugin_dir}/fence_cisco_ucs

#%%files -n fence-agents-unsupported
#%%defattr(-,root,root,-)
#%%config(noreplace) %%{_sysconfdir}/cluster/fence_na.conf
%{_sbindir}/fence_*
#%%exclude %%{_sbindir}/fence_cisco_ucs
%exclude %{_sbindir}/fence_dummy
%exclude %{_mandir}/man8/fence_dummy*
%{_mandir}/man8/fence_*
#%%exclude %%{_mandir}/man8/fence_cisco_ucs*
%{_libexecdir}/fence_*

%changelog
* Tue Aug 11 2015 kgronlund@suse.com
- Update to 4.0.20:
  * In some cases password string was expected twice what lead to 'Unable
    to login'
  * New fence agent fence_rcd_serial for DYI fence device (look at
    https://smcleod.net/rcd-stonith/ ; thanks to Sam McLeod)
  * Fence_pve should default to SSL (thanks to Thomas Lamprecht)
  * Fixes nroff error for fence_virsh (thanks to Adrian Vondendriesch)
  * Improve monitoring for fence_scsi
  * Fixes for devices which do not have port and obtaining status is not
    possible
  * fence_ipmilan no longer print password to debug info
  * Possibility to do force-ON even if device is already ON
  * Possibility to declare that device does not have ON or OFF (usually
    only reboot works)
* Wed Jul  1 2015 kgronlund@suse.com
- Update to 4.0.19:
  * New fence agent for Nova compute machines (thanks to Andrew
    Beekhof and Fabio)
  * Fixed issues with whitespaces in few fence agents (thanks to
    Christoph Berg)
  * User of RHEV-M can have less privileges with updated
    fence_rhevm (thanks to Rik Theys)
  * Verbose output now captures also text before command prompt is
    found
  * Support for HP Integrity Superdome X was added to fence_hpblade
    (thanks to Han Pilmeyer)
  * Fence agent for IBM z/VM now uses API that require less resource
    of device
* Wed Jun 10 2015 kgronlund@suse.com
- Update to 4.0.18:
  * fence_scsi has now implemented action 'monitor'
    (thanks to John Ruemker)
  * fence_scsi is now able to unfence devices added later
    (thanks to John Ruemker)
  * simplification of code thanks to auto-generation of help texts
  * when 'name' is entered on STDIN instead of 'name=value', warning
    is generated
* Tue Apr  7 2015 kgronlund@suse.com
- Update to 4.0.17:
  * HP iLO2 with firmware 2.27 has broken implementation of TLS negotation
    and SSLv3 is disabled by default (POODLE attack). Options --tls1.0
    (tls1.0 on stdin) was added to force using TLS v1.0. This options allows
    users to use that firmware with fence agents.
  * Fence agent for AMT password was not put correctly into environment.
  * Fix login process on bladecenter where 'last login' can occur in
    message of the day what mislead fence agent.
  * Cipher for fence_ipmilan was previously set to 0. It was found out
    that this not good default value, we will use default value (3) of
    ipmitool instead.
* Mon Mar  9 2015 kgronlund@suse.com
- Update to 4.0.16:
  * fence_kdump has implemented 'monitor' action that check if local node
    is capable of working with kdump
  * path to smnp(walk|get|set) can be set at runtime
  * new operation 'validate-all' for majority of agents that checks if
    entered parameters are sufficient without connecting to fence
    device. Be aware that some checks can be done only after we receive
    information from fence device, so these are not tested.
  * new operation 'list-status' that present CSV output (plug_number,
    plug_alias, plug_status) where status is ON/OFF/UNKNOWN
* Mon Feb  9 2015 kgronlund@suse.com
- Update to 4.0.15:
  * Tripp Lite PDUs are now supported by fence_tripplite_snmp (symlink to
    fence_apc_snmp)
  * Default values in metadata sometimes differ to those actually used,
    this is fixed now
  * improvements in testing
- Remove patch: 0001-Avoid-problem-with-broken-make-variable-expansion.patch
* Wed Jan  7 2015 kgronlund@suse.com
- Update to 4.0.14:
  * fence_zvmip for IBM z/VM is rewritten to Python
  * new fence agent for Emerson devices
  * fix invalid default ports for fence_eps and fence_amt
  * properly escape XML in other fields of metadata
  * a lot of refactoring and cleaning
* Mon Dec 15 2014 kgronlund@suse.com
- Update to 4.0.13:
  * new fence agent based on mpathpersist that offers better handling of
    multipath devices
  * improve support of fence_ilo_ssh on older firmwares
  * required packages are also required by autoconf during build time
  * fence_zvm now supports action 'monitor' (thanks to Neale Ferguson)
  * introduce --gnutlscli-path --sudo-path --ssh-path and --telnet-path;
    they are no longer hard-coded
  * order of XML parameters or options in --help is more stable now
  * fence_cisco_ucs did not set protocol prefix correctly with
  - -ssl-(in)secure
  * logging to syslog now works correctly also with \x00 as input
- Add patch: 0001-Avoid-problem-with-broken-make-variable-expansion.patch
* Thu Oct 16 2014 kgronlund@suse.com
- Update to 4.0.12:
  * new up-to-date wiki page with STDIN / command line arguments
    http://fedorahosted.org/cluster/wiki/FenceArguments
  * Fence agent fence_pve now supports --ssl-secure and --ssl-insecure
  (check certificate or not)
  * Fence agent for RHEV-M supports cookie based authentication
  (--use-cookies)
  * improvements in build system
  * Fix issue with regular expression in fence_rsb
  * Fix uninitialized EOL in fence_wti
- Remove backported patches:
  - 0001-fence_brocade-Add-support-for-list-action.patch
  - 0002-fencing-Monitor-is-not-working-correctly-without-lis.patch
  - 0003-fence_apc_snmp-Add-support-for-firmware-6.x.patch
  - 0004-fence_zvm-Add-support-for-on-and-status.patch
  - 0005-fence_zvm-Add-current-XML-metadata-to-test-suite.patch
  - 0006-build-Fix-automake-files-so-make-distcheck-works.patch
  - 0007-fencing-Add-new-options-ssl-secure-and-ssl-insecure.patch
  - 0008-tests-Update-XML-metadata-of-fence-agents.patch
  - 0009-fence_cisco_ucs-fence_vmware_soap-Logout-has-to-be-p.patch
  - 0010-fence_zvm-Fixes-for-better-upstream-inclusion.patch
  - 0011-fence_zvm-Add-support-for-on-improve-documentation.patch
  - 0012-fence_rhevm-Use-https-prefix-also-with-ssl-secure-an.patch
  - 0013-fence_apc-shell-timeout-was-used-instead-of-power-ti.patch
  - 0014-fence_rsb-Fix-62d90e3a0827fcdc5be632bdf4103d3c08b396.patch
  - 0015-fence_wti-Fix-invalid-eol.patch
  - 0016-fence_pve-Add-support-for-ssl-secure-and-ssl-insecur.patch
* Mon Oct 13 2014 kgronlund@suse.com
- Backport security and bug fixes (bnc#900879) (CVE-2014-0104)
  - fence_rhevm: Use https:// prefix also with --ssl-secure and --ssl-insecure
  - fence_apc: --shell-timeout was used instead of --power-timeout
  - fence_rsb: Fix 62d90e3a0827fcdc5be632bdf4103d3c08b39622
  - fence_wti: Fix invalid "eol"
  - fence_pve: Add support for --ssl-secure and --ssl-insecure
- Added patches:
  - 0012-fence_rhevm-Use-https-prefix-also-with-ssl-secure-an.patch
  - 0013-fence_apc-shell-timeout-was-used-instead-of-power-ti.patch
  - 0014-fence_rsb-Fix-62d90e3a0827fcdc5be632bdf4103d3c08b396.patch
  - 0015-fence_wti-Fix-invalid-eol.patch
  - 0016-fence_pve-Add-support-for-ssl-secure-and-ssl-insecur.patch
* Fri Oct  3 2014 kgronlund@suse.com
- Add requirement for python-suds (bnc#899664)
* Tue Sep 16 2014 kgronlund@suse.com
- Backport fixes from upstream (bnc#896833):
  + fence_brocade: Add support for 'list' action
  + fencing: Monitor is not working correctly without 'list' or 'status'
  + fence_apc_snmp: Add support for firmware 6.x
  + fence_zvm: Add support for "on" and "status"
  + fence_zvm: Add current XML metadata to test suite
  + [build] Fix automake files, so 'make distcheck' works
  + fencing: Add new options --ssl-secure and --ssl-insecure
  + [tests] Update XML metadata of fence agents
  + fence_cisco_ucs & fence_vmware_soap: Logout has to be performed even when fencing fails
  + fence_zvm: Fixes for better upstream inclusion
  + fence_zvm: Add support for 'on', improve documentation
- Added patches:
  + 0001-fence_brocade-Add-support-for-list-action.patch
  + 0002-fencing-Monitor-is-not-working-correctly-without-lis.patch
  + 0003-fence_apc_snmp-Add-support-for-firmware-6.x.patch
  + 0004-fence_zvm-Add-support-for-on-and-status.patch
  + 0005-fence_zvm-Add-current-XML-metadata-to-test-suite.patch
  + 0006-build-Fix-automake-files-so-make-distcheck-works.patch
  + 0007-fencing-Add-new-options-ssl-secure-and-ssl-insecure.patch
  + 0008-tests-Update-XML-metadata-of-fence-agents.patch
  + 0009-fence_cisco_ucs-fence_vmware_soap-Logout-has-to-be-p.patch
  + 0010-fence_zvm-Fixes-for-better-upstream-inclusion.patch
  + 0011-fence_zvm-Add-support-for-on-improve-documentation.patch
- Add dependency on python-requests
* Tue Jul  1 2014 kgronlund@suse.com
- Update to 4.0.10:
  * fence_scsi is reimplemented on top of fencing library
  * fence_zvm support distributed z/VM systems
  * support for --delay was added to fence_zvm
  * unmaintained fence agents were removed:
  * fence_baytech, fence_bullpap, fence_cpint, fence_mcdata,
  * fence_rackswitch, fence_vixel, fence_xcat
  * we do not plan to remove other agents
  * update fence_rsb to work with new firmware
* Tue Jul  1 2014 kgronlund@suse.com
- Update to 4.0.10:
  * fence_scsi is reimplemented on top of fencing library
  * fence_zvm support distributed z/VM systems
  * support for --delay was added to fence_zvm
  * unmaintained fence agents were removed:
  * fence_baytech, fence_bullpap, fence_cpint, fence_mcdata,
  * fence_rackswitch, fence_vixel, fence_xcat
  * we do not plan to remove other agents
  * update fence_rsb to work with new firmware
* Mon May 19 2014 kgronlund@suse.com
- Don't build in parallell (bnc#878580)
* Thu May 15 2014 kgronlund@suse.com
- Update to version 4.0.9 (bnc#877996)
  + Allow ssl connections to fallback to SSL3.0 negotiation
  + fence_vmware_soap: fix short/long option parsing traceback
  + fence_raritan: new fence agent for Raritan Dominion PX
  + fencing: Replace printing to stderr with proper logging solution
  + fence_wti: Action 'list' prints also named groups
  + fence_ipmilan: send empty password, if password is not entered
  + fence_vmware: Invalid arguments for vmware_get_outlets_vi()
  + fence_amt: sending password over env
  + fencing: Introduce new device option 'no_status'
  + fence_pve: new fence-agent for Proxmox VE
  + fence_ovh: --delay should be applied before attempt to login
- Exclude dummy fence agent fence_dummy (bnc#877950)
- Remove obsolete fence-agents-add-longdesc.patch
* Tue Feb 18 2014 kgronlund@suse.com
- Update to version 4.0.7
  + support for firmware v1.40 for WTI (MPC series)
  + nss_wrapper used for fence_ilo was replaced by gnutls-cli
  + --delay was not respected in fence_vmware_soap
  + fabric fence agents have 'off' as default action
  + fence_scsi now generates correct key on corosync clusters
  + regression was found in fence_ipmilan where -P and -L were
    interchanged on command line
    (there was no problem with long options and input from STDIN)
  + fence_vmware_soap now fails with proper error message when user does
    not have enough privileges
* Sat Jan 11 2014 kgronlund@suse.com
- Update to version 4.0.6
  + support for Dell Drac MC was added to fence_drac5
  + support for Tripplite PDU was added to fence_apc
    (thanks to Bogdan Dobrelya)
  + support for AMT was added as new fence agent fence_amt
    (thanks to Ondrej Mular)
  + support for identification of  virtual machine using UUID was
    added to fence_virsh (thanks to Bogdan)
  + fence_ipmilan was ported from C to Python using standard
    fencing library (thanks to Ondrej)
* Thu Oct 31 2013 kgronlund@suse.com
- Update to version 4.0.5
  + fence agent for RSB now works correctly also with newer
    firmware
  + fence agent for WTI now supports not only port numbers but also
    named port groups
  + fence agent for VMWare SOAP now report if user does not have
    enough privileges
  + add a Relax NG for XML metadata of fence agents and require
    them to be correct in order to build a fence agent
  + fix problems found thanks to previous Relax NG
* Mon Sep  9 2013 ygao@suse.com
- Update to version 4.0.3
* Thu Jul  5 2012 dmuhamedagic@suse.com
- add longdesc as copy of shortdesc to produce valid XML (bnc#770043)
* Tue Jun 26 2012 dmuhamedagic@suse.com
- remove fence-ack-manual from supported, it has effect only with
  fenced
- add links to /usr/lib64/stonith/plugins/rhcs
* Thu Jun 21 2012 lmb@novell.com
- Rename two packages to SUSE package names in Requires
- Split into fence-agents and fence-agents-unsupported
- SUSE-fy spec file
* Thu Nov  3 2011 msvec@suse.com
- Initial version 3.1.6
